<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Blog-Post</title>
    <!--------------------------------(syntax hilighting)------------------------------------->
    <link
      rel="stylesheet"
      href="//cdn.jsdelivr.net/gh/highlightjs/cdn-release@10.4.0/build/styles/default.min.css"
    />
    <link rel="stlyesheet" href="./prism.css" />
    <!-------------------------------------(scripts)------------------------------------------>
    <script src="//cdn.jsdelivr.net/gh/highlightjs/cdn-release@10.4.0/build/highlight.min.js"></script>
    <script async src="./prism.js"></script>

    <link rel="stylesheet" href="./css/bootstrap.css" />
    <link rel="stylesheet" href="./css/bootstrap.grid.css" />
    <link rel="stylesheet" href="./css/bootstrap.min.css" />
    <link rel="stylesheet" href="./css/bootstrap-reboot.min.css" />
    <link rel="stylesheet" href="./css/bootstrap.css.map" />
    <link rel="stylesheet" href="./css/blog-home.css" />
    <link rel="stylesheet" href="./css/prism.css" />
    <script async defer src="./css/prism.js"></script>
  </head>

  <body>
    <p>
      This post will demonstrate how I setup rails for bdd. I mainly use 3 gems
      spork, rspec and cucumber.
    </p>
    <h2 id="why-spork">Why Spork?</h2>
    <p>
      I use spork to <strong>run my tests faster</strong>. I experianced 2x to
      5x faster test running time when I use spork. My Gemfile look similar to
      the below one.
    </p>
    <p>
      {% highlight ruby %} group :development, :test do gem ‘rspec-rails’ gem
      ‘spork’, :git =&gt; ‘git@github.com:sporkrb/spork.git’ gem ‘guard-spork’
      gem ‘guard-rspec’ gem ‘guard-cucumber’ end
    </p>
    <p>
      group :test do gem ‘cucumber-rails’, :require =&gt; false end {%
      endhighlight %}
    </p>
    <h2 id="the-setup">The Setup</h2>
    <p>
      So I added all the needed gems to my Gemfile and now its time to setup
      rspec and cucumber. Now setup rspec and cucumber with the below commands
      which will generate related files and directory structure.
    </p>
    <p>
      {% highlight sh %} rails g rspec:install rails g cucumber:install {%
      endhighlight %}
    </p>
    <p>Now you need to setup spork for rspec and cucumber.</p>
    <p>{% highlight sh %} spork rspec –bootstrap {% endhighlight %}</p>
    <p>
      The above command will generate <code>spork.prefork</code> and
      <code>spork.eachrun</code> blocks in the <code>spec/spec_helper.rb</code>.
      Now you need to manually move the code generated by
      <code>rails g rspec:install</code> into the
      <code>spork.prefork</code> block.
    </p>
    <p>{% highlight sh %} spork cucumber –bootstrap {% endhighlight %}</p>
    <p>
      As you done for rspec, the above command will generate the
      <code>spork.prefork</code> and <code>spork.eachrun</code> blocks in the
      <code>features/support/env.rb</code> and you need to move the code
      generated by <code>rails g cucumber:install</code> into the
      <code>spork.prefork</code> block.
    </p>
    <p>
      Now its time to setup guard, which will watch your application code and
      tests and run the tests when ever you update the code/tests.
    </p>
    <p>
      {% highlight sh %} guard init spork guard init rspec guard init cucumber
      {% endhighlight %}
    </p>
    <p>
      This above command will generate <strong>Guardfile</strong> and add
      configuration for spork, rspec and cucumber.
    </p>
    <p>
      Then you need to add <code>cli: '--drb'</code> to rspec and cucmber guard
      configuration, to run them over the Spork DRb server.
    </p>
    <p>An example configuration with cli option will look like,</p>
    <p>
      {% highlight ruby %} guard ‘cucumber’, cli: ‘–drb’ do
      watch(%r{^features/.+.feature<span class="math inline"
        >$}) watch(%r{^features/support/.+$</span
      >}) { ‘features’ } watch(%r{^features/step_definitions/(.+)_steps.rb$}) {
      |m| Dir[File.join(“**/#{m[1]}.feature”)][0] || ‘features’ } end {%
      endhighlight %}
    </p>
    <p>Thats it. My bdd setup for rails is done.</p>
  </body>
</html>
